Imports System.Collections
Imports System.ComponentModel
Imports System.Text
Imports System.Web.UI
Imports System.Web.UI.WebControls

Namespace CustomControlLib
    <DefaultProperty("Text"), ToolboxData("<{0}:PalindromeCheckerControl runat=server></{0}:PalindromeCheckerControl>")>
    Public Class PalindromeCheckerRenderedControl
        Inherits WebControl

        Public Event PalindromeFound As EventHandler ' public event

        Private alPalindromes As New ArrayList()


        <Category("Appearance"), DefaultValue(""), Localizable(True)>
        Public Property Text() As String
            Get
                Dim s As String = CType(ViewState("Text"), String)
                Return (If((s Is Nothing), String.Empty, s))
            End Get
            Set(ByVal value As String)
                ViewState("Text") = value

                Dim _text As String = value
                Me.alPalindromes = CType(Me.ViewState("palindromes"), ArrayList)
                If Me.alPalindromes Is Nothing Then
                    Me.alPalindromes = New ArrayList()
                End If
                If Me.CheckForPalindrome() Then
                    RaiseEvent PalindromeFound(Me, EventArgs.Empty)
                    alPalindromes.Add(_text)
                End If
                ViewState.Add("palindromes", alPalindromes)
            End Set
        End Property



        Protected Sub RenderPalindromesInTable(ByVal output As HtmlTextWriter)
            output.AddAttribute(HtmlTextWriterAttribute.Width, "50%")
            output.AddAttribute(HtmlTextWriterAttribute.Border, "1")
            output.RenderBeginTag(HtmlTextWriterTag.Table) '<table>
            For Each s As String In Me.alPalindromes
                output.RenderBeginTag(HtmlTextWriterTag.Tr) ' <tr>
                output.AddAttribute(HtmlTextWriterAttribute.Align, "left")
                output.AddStyleAttribute(HtmlTextWriterStyle.FontSize, "medium")
                output.AddStyleAttribute(HtmlTextWriterStyle.Color, "blue")
                output.RenderBeginTag(HtmlTextWriterTag.Td) ' <td>
                output.Write(s)
                output.RenderEndTag() ' </td>
                output.RenderEndTag() ' </tr>
            Next s
            output.RenderEndTag() ' </table>
        End Sub


#If false Then
        Protected Overrides Sub RenderContents(ByVal output As HtmlTextWriter)
            If Me.CheckForPalindrome() Then
                output.Write("This is a palindrome: <br>")
                output.Write("<span style= 'font-style: bold; " & ControlChars.CrLf & "         font-size: x-large; color:Blue;'>")
                output.Write(Text)
                output.Write("</B>")
                output.Write("</FONT>")
            Else
                output.Write("This is NOT a palindrome <br>")
                output.Write("<FONT size=5 color=red>")
                output.Write("<B>")
                output.Write(Text)
                output.Write("</B>")
                output.Write("</FONT>")
            End If
        End Sub
#End If

        Protected Overrides Sub RenderContents(ByVal output As HtmlTextWriter)
            If Me.CheckForPalindrome() Then
                output.Write("This is a palindrome: <br>")
                output.RenderBeginTag(HtmlTextWriterTag.Font)
                output.AddStyleAttribute(HtmlTextWriterStyle.Color, "blue")
                output.RenderBeginTag(HtmlTextWriterTag.B)
                output.Write(Text)
                output.RenderEndTag() ' bold
                output.RenderEndTag() ' font
            Else
                output.Write("This is NOT a palindrome: <br>")
                output.RenderBeginTag(HtmlTextWriterTag.Font)
                output.AddStyleAttribute(HtmlTextWriterStyle.Color, "red")
                output.RenderBeginTag(HtmlTextWriterTag.B)
                output.Write(Text)
                output.RenderEndTag() ' bold
                output.RenderEndTag() ' font
            End If
            output.Write("<br>")
            RenderPalindromesInTable(output)
        End Sub



        Protected Function StripNonAlphanumerics(ByVal str As String) As String
            Dim strStripped As String = CType(str.Clone(), String)
            If str IsNot Nothing Then
                Dim rgc() As Char = strStripped.ToCharArray()
                Dim i As Integer = 0
                For Each c As Char In rgc
                    If Char.IsLetterOrDigit(c) Then
                        i += 1
                    Else
                        strStripped = strStripped.Remove(i, 1)
                    End If
                Next c
            End If
            Return strStripped
        End Function
        Protected Function CheckForPalindrome() As Boolean
            If Me.Text IsNot Nothing Then
                Dim strControlText As String = Me.Text
                Dim strTextToUpper As String = Nothing
                strTextToUpper = Text.ToUpper()
                strControlText = Me.StripNonAlphanumerics(strTextToUpper)
                Dim rgcReverse() As Char = strControlText.ToCharArray()
                Array.Reverse(rgcReverse)
                Dim strReverse As New String(rgcReverse)
                If strControlText = strReverse Then
                    Return True
                Else
                    Return False
                End If
            Else
                Return False
            End If
        End Function
    End Class
End Namespace
