Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Collections

Namespace ControlsORama
    Partial Public Class PalindromeCheckerUserControl
        Inherits System.Web.UI.UserControl

        Public Event PalindromeFound As EventHandler ' public event
        Private alPalindromes As ArrayList

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)

        End Sub


        Private _text As String

        Public Property Text() As String
            Get
                Return _text
            End Get

            Set(ByVal value As String)
                _text = value

                Me.alPalindromes = CType(Me.ViewState("palindromes"), ArrayList)
                If Me.alPalindromes Is Nothing Then
                    Me.alPalindromes = New ArrayList()
                End If

                If Me.CheckForPalindrome() Then
                    RaiseEvent PalindromeFound(Me, EventArgs.Empty)

                    alPalindromes.Add(_text)

                    Me.labelPalindromeStatus.Text = String.Format("This is a palindrome <br/><FONT size=""5"" color=""blue""><B>{0}</B></FONT>", _text)
                Else
                    Me.labelPalindromeStatus.Text = String.Format("This is NOT a palindrome <br/><FONT size=""5"" color=""red""><B>{0}</B></FONT>", _text)
                End If

                Me.ViewState.Add("palindromes", alPalindromes)
                Me.BuildPalindromesTable()

            End Set
        End Property



        Protected Function StripNonAlphanumerics(ByVal str As String) As String
            Dim strStripped As String = CType(str.Clone(), String)
            If str IsNot Nothing Then
                Dim rgc() As Char = strStripped.ToCharArray()
                Dim i As Integer = 0
                For Each c As Char In rgc
                    If Char.IsLetterOrDigit(c) Then
                        i += 1
                    Else
                        strStripped = strStripped.Remove(i, 1)
                    End If
                Next c
            End If

            Return strStripped
        End Function

        Protected Function CheckForPalindrome() As Boolean
            If Me.Text IsNot Nothing Then
                Dim strControlText As String = Me.Text
                Dim strTextToUpper As String = Nothing

                strTextToUpper = Text.ToUpper()

                strControlText = Me.StripNonAlphanumerics(strTextToUpper)

                Dim rgcReverse() As Char = strControlText.ToCharArray()
                Array.Reverse(rgcReverse)
                Dim strReverse As New String(rgcReverse)
                If strControlText = strReverse Then
                    Return True
                Else
                    Return False
                End If
            Else
                Return False
            End If
        End Function

        Protected Sub BuildPalindromesTable()
            Me.alPalindromes = CType(Me.ViewState("palindromes"), ArrayList)
            If Me.alPalindromes IsNot Nothing Then
                For Each s As String In Me.alPalindromes
                    Dim tableCell As New TableCell()
                    tableCell.BorderStyle = BorderStyle.Double
                    tableCell.BorderWidth = 3
                    tableCell.Text = s
                    Dim tableRow As New TableRow()
                    tableRow.Cells.Add(tableCell)
                    Me.Table1.Rows.Add(tableRow)
                Next s
            End If
        End Sub

        Protected Sub Button1_Click(ByVal sender As Object, ByVal e As EventArgs)
            Me.Text = Me.TextBox1.Text
            CheckForPalindrome()

        End Sub

    End Class
End Namespace
