Imports System.ComponentModel
Imports System.Text
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Collections

Namespace CustomControlLib
    <DefaultProperty("Text"), ToolboxData("<{0}:PalindromeCheckerCompositeControl runat=server></{0}:PalindromeCheckerCompositeControl>")>
    Public Class PalindromeCheckerCompositeControl
        Inherits CompositeControl

        <Bindable(True), Category("Appearance"), DefaultValue(""), Localizable(True)>
        Private _text As String

        Public Property Text() As String
            Get
                Return _text
            End Get
            Set(ByVal value As String)
                _text = value

                Me.alPalindromes = CType(Me.ViewState("palindromes"), ArrayList)
                If Me.alPalindromes Is Nothing Then
                    Me.alPalindromes = New ArrayList()
                End If

                If Me.CheckForPalindrome() Then
                    RaiseEvent PalindromeFound(Me, EventArgs.Empty)

                    alPalindromes.Add(_text)

                    literalcontrolPalindromeStatus.Text = String.Format("This is a palindrome <br/><FONT size=""5"" color=""blue""><B>{0}</B></FONT>", _text)
                Else
                    literalcontrolPalindromeStatus.Text = String.Format("This is NOT a palindrome <br/><FONT size=""5"" color=""red""><B>{0}</B></FONT>", _text)
                End If


                Me.ViewState.Add("palindromes", alPalindromes)
                Me.BuildPalindromesTable()

            End Set
        End Property



        Protected textboxPalindrome As TextBox
        Protected buttonCheckForPalindrome As Button
        Protected labelForTextBox As Label
        Protected literalcontrolPalindromeStatus As LiteralControl
        Public Event PalindromeFound As EventHandler

        Protected tablePalindromes As Table
        Protected alPalindromes As ArrayList

        Protected Function StripNonAlphanumerics(ByVal str As String) As String
            Dim strStripped As String = CType(str.Clone(), String)

            If str IsNot Nothing Then
                Dim rgc() As Char = strStripped.ToCharArray()

                Dim i As Integer = 0

                For Each c As Char In rgc
                    If Char.IsLetterOrDigit(c) Then
                        i += 1

                    Else
                        strStripped = strStripped.Remove(i, 1)
                    End If
                Next c
            End If

            Return strStripped
        End Function

        Protected Function CheckForPalindrome() As Boolean
            If Me.Text IsNot Nothing Then
                Dim strControlText As String = Me.Text
                Dim strTextToUpper As String = Nothing

                strTextToUpper = Text.ToUpper()

                strControlText = Me.StripNonAlphanumerics(strTextToUpper)

                Dim rgcReverse() As Char = strControlText.ToCharArray()
                Array.Reverse(rgcReverse)
                Dim strReverse As New String(rgcReverse)
                If strControlText = strReverse Then
                    Return True
                Else
                    Return False
                End If
            Else
                Return False
            End If
        End Function

        Public Sub OnCheckPalindrome(ByVal o As Object, ByVal ea As EventArgs)
            Me.Text = Me.textboxPalindrome.Text
            Me.CheckForPalindrome()
        End Sub

        Protected Overrides Sub CreateChildControls()
            labelForTextBox = New Label()
            labelForTextBox.Text = "Enter a palindrome: "
            Me.Controls.Add(labelForTextBox)

            textboxPalindrome = New TextBox()
            Me.Controls.Add(textboxPalindrome)

            Controls.Add(New LiteralControl("<br/>"))

            buttonCheckForPalindrome = New Button()
            buttonCheckForPalindrome.Text = "Check for Palindrome"
            AddHandler buttonCheckForPalindrome.Click, AddressOf OnCheckPalindrome
            Me.Controls.Add(buttonCheckForPalindrome)

            Controls.Add(New LiteralControl("<br/>"))

            literalcontrolPalindromeStatus = New LiteralControl()
            Controls.Add(literalcontrolPalindromeStatus)

            Controls.Add(New LiteralControl("<br/>"))

            Me.tablePalindromes = New Table()
            Me.Controls.Add(tablePalindromes)

            Me.ChildControlsCreated = True
        End Sub

        Protected Sub BuildPalindromesTable()
            Me.alPalindromes = CType(Me.ViewState("palindromes"), ArrayList)
            If Me.alPalindromes IsNot Nothing Then
                For Each s As String In Me.alPalindromes
                    Dim tableCell As New TableCell()
                    tableCell.BorderStyle = BorderStyle.Double
                    tableCell.BorderWidth = 3
                    tableCell.Text = s
                    Dim tableRow As New TableRow()
                    tableRow.Cells.Add(tableCell)
                    Me.tablePalindromes.Rows.Add(tableRow)
                Next s
            End If
        End Sub


    End Class
End Namespace
