Imports System.Web.UI
Imports System.Web.UI.WebControls

Namespace UseDataCaching
    Partial Public Class CacheDependencies
        Inherits System.Web.UI.Page
        Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
            If Not IsPostBack Then
                ButtonSaveAsXML_Click(Nothing, Nothing)
            End If
            CacheWithFileDependency()

        End Sub

        Protected Sub ButtonSaveAsXML_Click(ByVal sender As Object, ByVal e As EventArgs)
            Dim quotesCollection As New QuotesCollection()
            quotesCollection.Synthesize()
            Dim strFilePathXml As String = Server.MapPath(Request.ApplicationPath & "\App_Data\QuotesCollection.xml")
            Dim strFilePathSchema As String = Server.MapPath(Request.ApplicationPath & "\App_Data\QuotesCollection.xsd")
            quotesCollection.WriteXmlSchema(strFilePathSchema)
            quotesCollection.WriteXml(strFilePathXml)

        End Sub

        Protected Sub CacheWithFileDependency()
            Dim quotesCollection As QuotesCollection

            Trace.Warn("Page_Load", "Testing cache ")
            quotesCollection = CType(Cache("QuotesCollection"), QuotesCollection)

            If quotesCollection Is Nothing Then
                Trace.Warn("Page_Load", "Not found in cache")
                quotesCollection = New QuotesCollection()

                Dim strFilePathXml As String = Server.MapPath(Request.ApplicationPath & "\App_Data\QuotesCollection.xml")
                Dim strFilePathSchema As String = Server.MapPath(Request.ApplicationPath & "\App_Data\QuotesCollection.xsd")

                quotesCollection.ReadXmlSchema(strFilePathSchema)
                quotesCollection.ReadXml(strFilePathXml)

                Dim cacheDependency As New System.Web.Caching.CacheDependency(strFilePathXml)

                Dim _global As [Global] = TryCast(HttpContext.Current.ApplicationInstance, [Global])

                HttpContext.Current.Cache.Insert("QuotesCollection",
                             quotesCollection,
                             cacheDependency,
                             System.Web.Caching.Cache.NoAbsoluteExpiration,
                             System.Web.Caching.Cache.NoSlidingExpiration,
                             System.Web.Caching.CacheItemPriority.Default,
                             AddressOf _global.OnRemoveQuotesCollection)
            End If

            Me.GridView1.DataSource = quotesCollection
            Me.DataBind()
        End Sub


    End Class
End Namespace
