Imports System.Web.Security
Imports System.Web.SessionState
Imports System.Web.Caching

Namespace UseDataCaching
    Public Class [Global]
        Inherits HttpApplication

        Private _bReloadQuotations As Boolean = False

        Public Sub OnRemoveQuotesCollection(ByVal key As String, ByVal val As Object, ByVal r As CacheItemRemovedReason)
            ' Do something about the dependency Change
            If r = CacheItemRemovedReason.DependencyChanged Then
                _bReloadQuotations = True
            End If
        End Sub

        Protected Sub ReloadQuotations()
            Dim quotesCollection As New QuotesCollection()

            Dim strFilePathXml As String = Server.MapPath(HttpContext.Current.Request.ApplicationPath & "\App_Data\QuotesCollection.xml")
            Dim strFilePathSchema As String = Server.MapPath(HttpContext.Current.Request.ApplicationPath & "\App_Data\QuotesCollection.xsd")

            quotesCollection.ReadXmlSchema(strFilePathSchema)
            quotesCollection.ReadXml(strFilePathXml)

            Dim cacheDependency As New System.Web.Caching.CacheDependency(strFilePathXml)

            HttpContext.Current.Cache.Insert("QuotesCollection", quotesCollection, cacheDependency, System.Web.Caching.Cache.NoAbsoluteExpiration, System.Web.Caching.Cache.NoSlidingExpiration, System.Web.Caching.CacheItemPriority.Default, AddressOf Me.OnRemoveQuotesCollection)
        End Sub


        Protected Sub Application_BeginRequest(ByVal sender As Object, ByVal e As EventArgs)
            If _bReloadQuotations = True Then
                ReloadQuotations()
                _bReloadQuotations = False
            End If

        End Sub

        Protected Sub Application_Start(ByVal sender As Object, ByVal e As EventArgs)

        End Sub

        Protected Sub Session_Start(ByVal sender As Object, ByVal e As EventArgs)

        End Sub

        Protected Sub Application_AuthenticateRequest(ByVal sender As Object, ByVal e As EventArgs)

        End Sub

        Protected Sub Application_Error(ByVal sender As Object, ByVal e As EventArgs)

        End Sub

        Protected Sub Session_End(ByVal sender As Object, ByVal e As EventArgs)

        End Sub

        Protected Sub Application_End(ByVal sender As Object, ByVal e As EventArgs)

        End Sub

    End Class
End Namespace
