Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Collections

Namespace DebugORama
    Partial Public Class TraceMe
        Inherits System.Web.UI.Page
        Private alTableEntries As ArrayList = Nothing

        Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
            alTableEntries = CType(Me.Session("TableEntries"), ArrayList)
            If alTableEntries Is Nothing Then
                Trace.Warn("Page_Load", "alTableEntries is null")
                alTableEntries = New ArrayList()
            End If
            AssembleTable()
        End Sub

        Protected Sub AssembleTable()
            Me.Table1.Rows.Clear()

            For Each s As String In alTableEntries
                Trace.Write("AssembleTable", "String found: " & s)
                Dim row As New TableRow()
                Dim cell As New TableCell()
                cell.Text = s
                row.Cells.Add(cell)
                Me.Table1.Rows.Add(row)
            Next s
        End Sub

        Protected Sub Button1_Click(ByVal sender As Object, ByVal e As EventArgs)
            Trace.Write("Button1_Click", "Adding string: " & Me.TextBox1.Text)
            alTableEntries.Add(Me.TextBox1.Text)
            Me.Session("TableEntries") = alTableEntries
            AssembleTable()
        End Sub
    End Class

End Namespace
