Imports System.Text
Imports System.Collections

Namespace TimingModule
    Public Interface ITimingModule
        Function GetAverageLengthOfRequest() As TimeSpan
    End Interface


    Public Class Timer
        Implements IHttpModule, ITimingModule
        Protected _alRequestDurations As New ArrayList()

      Public Sub New()
      End Sub

      Public Sub OnBeginRequest(ByVal o As Object, ByVal ea As EventArgs)
               Dim dateTimeBeginRequest As Date = Date.Now


         Dim ctx As HttpContext
         ctx = HttpContext.Current
         ctx.Items("dateTimeBeginRequest") = dateTimeBeginRequest
      End Sub

      Public Sub OnEndRequest(ByVal o As Object, ByVal ea As EventArgs)
         Dim dateTimeEndRequest As Date = Date.Now

         Dim ctx As HttpContext
         ctx = HttpContext.Current
         Dim dateTimeBeginRequest As Date = CDate(ctx.Items("dateTimeBeginRequest"))

         Dim duration As TimeSpan = dateTimeEndRequest.Subtract(dateTimeBeginRequest)

         ctx.Response.Write("<b>From the TimingModule: This request took " & duration.ToString() & "</b></br>")
         _alRequestDurations.Add(duration)
      End Sub

      Public Function GetAverageLengthOfRequest() As TimeSpan Implements ITimingModule.GetAverageLengthOfRequest
          Dim lTicks As Long = 0
          For Each timespanDuration As TimeSpan In Me._alRequestDurations
              lTicks += timespanDuration.Ticks
          Next timespanDuration

          Dim lAverageTicks As Long = lTicks \ _alRequestDurations.Count
          Dim timespanAverageDuration As New TimeSpan(lAverageTicks)
          Return timespanAverageDuration
      End Function


      Public Sub Init(ByVal httpApp As HttpApplication) Implements IHttpModule.Init
          AddHandler httpApp.BeginRequest, AddressOf OnBeginRequest

          AddHandler httpApp.EndRequest, AddressOf OnEndRequest

      End Sub
      Public Sub Dispose() Implements IHttpModule.Dispose
      End Sub

    End Class
End Namespace
