﻿Namespace MVCORama
    Public Class DotNetLinksController
        Inherits System.Web.Mvc.Controller

        Private dotNetLinksManager As New DotNetLinksManager()
        '
        ' GET: /DotNetLinks

        Function Index() As ActionResult
            Try
                Dim dotNetLinks = dotNetLinksManager.GetAllLinks().ToList()
                Return View("Index", dotNetLinks)
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
                Return View()
            End Try
        End Function

        '
        ' GET: /DotNetLinks/Details/5

        Public Function Details(ByVal id As Integer) As ActionResult
            Try
                Dim dotNetLink As DotNetLink = dotNetLinksManager.Find(id)
                If dotNetLink IsNot Nothing Then
                    Return View("Details", dotNetLink)
                Else
                    Return View()
                End If
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
                Return View()
            End Try
        End Function


        '
        ' GET: /DotNetLinks/Create

        Public Function Create() As ActionResult
            Return View()
        End Function

        Private Shared Function DotNetLinkFromFormsCollection(ByVal collection As FormCollection) As DotNetLink
            Dim dotNetLink As New DotNetLink()

            dotNetLink.DisplayName = collection("DisplayName")
            dotNetLink.URL = collection("URL")
            Return dotNetLink
        End Function

        '
        ' POST: /DotNetLinks/Create

        <AcceptVerbs(HttpVerbs.Post)> _
        Public Function Create(ByVal collection As FormCollection) As ActionResult
            Try
                Dim dotNetLink As DotNetLink = DotNetLinkFromFormsCollection(collection)

                If dotNetLinksManager.Find(dotNetLink.ID) Is Nothing Then
                    dotNetLinksManager.Add(dotNetLink)

                    dotNetLinksManager.Save()
                End If

                Return RedirectToAction("Index")
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
                Return View()
            End Try
        End Function

        ' handle editing...
        Public Function Edit(ByVal id As Integer) As ActionResult
            Try
                Dim dotNetLink As DotNetLink = dotNetLinksManager.Find(id)
                If dotNetLink IsNot Nothing Then
                    Return View("Edit", dotNetLink)
                End If
                Return View()

            Catch ex As Exception
                Debug.WriteLine(ex.Message)
                Return View()
            End Try
        End Function

        <AcceptVerbs(HttpVerbs.Post)> _
        Public Function Edit(ByVal id As Integer, ByVal collection As FormCollection) As ActionResult
            Try
                ' TODO: Add update logic here
                Dim dotNetLink As DotNetLink = dotNetLinksManager.Find(id)
                UpdateModel(dotNetLink)

                dotNetLinksManager.Save()

                Return RedirectToAction("Index")
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
                Return View()
            End Try
        End Function

        ' Methods for deleting
        Public Function Delete(ByVal id As Integer) As ActionResult
            Try
                Dim dotNetLink As DotNetLink = dotNetLinksManager.Find(id)

                If dotNetLink IsNot Nothing Then
                    Return View("Delete", dotNetLink)
                Else
                    Return View()
                End If
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
                Return View()
            End Try
        End Function

        <AcceptVerbs(HttpVerbs.Post)> _
        Public Function Delete(ByVal id As Integer, ByVal formsCollection As FormCollection) As ActionResult
            Try
                Dim dotNetLink As DotNetLink = dotNetLinksManager.Find(id)

                If dotNetLink IsNot Nothing Then
                    dotNetLinksManager.Delete(dotNetLink)
                    dotNetLinksManager.Save()
                    Return RedirectToAction("Index")
                Else
                    Return View()
                End If
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
                Return View()
            End Try
        End Function
    End Class
End Namespace