Imports System.Web.UI
Imports System.Web.UI.WebControls

Namespace AJAXORama
    Partial Public Class GroupChat
        Inherits System.Web.UI.Page
        Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
            ManageUI()
            RefreshConversation()
        End Sub

        Protected Function GetUserID() As String
            Dim strUserID As String = CStr(Session("UserID"))
            Return strUserID
        End Function

        ' other code goes here...
        Private Sub ManageUI()
            If GetUserID() Is Nothing Then
                ' if this is the first request, then get the user's ID
                TextBoxMessage.Enabled = False
                TextBoxConversation.Enabled = False
                ButtonAddYourMessage.Enabled = False

                ButtonSubmitID.Enabled = True
                TextBoxUserID.Enabled = True
            Else
                ' if this is the first request, then get the user's ID
                TextBoxMessage.Enabled = True
                TextBoxConversation.Enabled = True
                ButtonAddYourMessage.Enabled = True

                ButtonSubmitID.Enabled = False
                TextBoxUserID.Enabled = False
            End If
        End Sub

        Private Sub RefreshConversation()
            Dim messages As List(Of String) = CType(Cache("Messages"), List(Of String))
            If messages IsNot Nothing Then
                Dim strConversation As String = ""

                Dim nMessages As Integer = messages.Count

                For i As Integer = nMessages - 1 To 0 Step -1
                    Dim s As String

                    s = messages(i)
                    strConversation &= s
                    strConversation &= vbCrLf
                Next i

                TextBoxConversation.Text = strConversation
            End If
        End Sub

        Protected Sub ButtonSubmitID_Click(ByVal sender As Object, ByVal e As EventArgs)
            Session("UserID") = TextBoxUserID.Text
            ManageUI()
        End Sub

        Protected Sub ButtonAddYourMessage_Click(ByVal sender As Object, ByVal e As EventArgs)
            ' Add the message to the conversation...
            If Me.TextBoxMessage.Text.Length > 0 Then
                Dim messages As List(Of String) = CType(Cache("Messages"), List(Of String))
                If messages IsNot Nothing Then
                    TextBoxConversation.Text = ""

                    Dim strUserID As String = GetUserID()

                    If strUserID IsNot Nothing Then
                        messages.Add(strUserID & ": " & TextBoxMessage.Text)
                        RefreshConversation()
                        TextBoxMessage.Text = ""
                    End If
                End If
            End If
        End Sub
    End Class
End Namespace
