Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.ServiceModel.Activation

Namespace SilverlightAndWCF.Web
    <DataContract, DataContractFormat> _
    Public Class ProductInfo

        Private _product As String

        <DataMember> _
        Public Property Product() As String
            Get
                Return _product
            End Get
            Set(ByVal value As String)
                _product = value
            End Set
        End Property


        Private _description As String

        <DataMember> _
        Public Property Description() As String
            Get
                Return _description
            End Get
            Set(ByVal value As String)
                _description = value
            End Set
        End Property


        Private _price As Double

        <DataMember> _
        Public Property Price() As Double
            Get
                Return _price
            End Get
            Set(ByVal value As Double)
                _price = value
            End Set
        End Property
    End Class


    Public Class Products
        Inherits List(Of ProductInfo)
        Public Sub New()
            Dim productInfo As New ProductInfo()

            productInfo = New ProductInfo()
            productInfo.Product = "Solidbody"
            productInfo.Description = "Flame maple top" & "mahogany body. Rosewood fingerboard. " & "One piece mahogany neck. Two humbucking " & "pickups. With case."
            productInfo.Price = 2500.00
            Add(productInfo)

            productInfo = New ProductInfo()
            productInfo.Product = "Bolt Neck Guitar"
            productInfo.Description = "Solid ash body. Maple neck and fingerboard. Three single coil pickups. With case."
            productInfo.Price = 1900.88
            Add(productInfo)

            productInfo = New ProductInfo()
            productInfo.Product = "Semi Hollowbody"
            productInfo.Description = "Flame maple top. Laminated maple sides and back. Rosewood fingerboard. One piece mahogany neck. Two humbucking pickups. With case."
            productInfo.Price = 2800.95
            Add(productInfo)

            productInfo = New ProductInfo()
            productInfo.Product = "Custom 24 Fret"
            productInfo.Description = "Flame maple top, mahogany body. Rosewood fingerboard. One piece mahogany neck. Abalone inlays, Two humbucking pickups. With case."
            productInfo.Price = 2500.00
            Add(productInfo)

            productInfo = New ProductInfo()
            productInfo.Product = "Dreadnought Acoustic"
            productInfo.Description = "Spruce top. Rosewood back and sides. Precision tuners. Rosewood fingerboard. With case."
            productInfo.Price = 2860.15
            Add(productInfo)

            productInfo = New ProductInfo()
            productInfo.Product = "Northwind Nylon String"
            productInfo.Description = "Spruce top, rosewood back and sides. Ebony fingerboard. One piece rosewood neck. EQ electronics. With case."
            productInfo.Price = 3300.95
            Add(productInfo)

            productInfo = New ProductInfo()
            productInfo.Product = "Trey Research Country Guitar"
            productInfo.Description = "Solid ash body. Maple neck and fingerboard. Two single coil pickups. With case."
            productInfo.Price = 1250.88
            Add(productInfo)

            productInfo = New ProductInfo()
            productInfo.Product = "Trey Research Solid Guitar"
            productInfo.Description = "Solid Mahogany body. Mahogany neck. Rosewood fingerboard. Two humbucking pickups. With case."
            productInfo.Price = 1750.88
            Add(productInfo)

            productInfo = New ProductInfo()
            productInfo.Product = "Trey Research Special P-90"
            productInfo.Description = "Solid Mahogany body. Mahogany neck. Rosewood fingerboard. Two P-90 pickups. With case."
            productInfo.Price = 1250.88
            Add(productInfo)
        End Sub
    End Class

    <ServiceContract(Namespace := ""), AspNetCompatibilityRequirements (RequirementsMode := AspNetCompatibilityRequirementsMode.Allowed)> _
    Public Class ProductsService
        Private Shared products As New Products()

        <OperationContract> _
        Public Sub DoWork()
            ' Add your operation implementation here
            Return
        End Sub

        ' Add more operations here and mark them with [OperationContract]
        <OperationContract> _
        Public Function GetProducts() As Products
            Return ProductsService.products
        End Function

        <OperationContract> _
        Private Function GetProduct(ByVal key As String) As ProductInfo
            Return ProductsService.products.Find(Function(productInfo)
                                                     If productInfo.Product = key Then
                                                         Return True
                                                     Else
                                                         Return False
                                                     End If
                                                 End Function)
        End Function

    End Class
End Namespace
