Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports System.Windows.Media.Imaging

Namespace SilverlightAnimations
    Partial Public Class MainPage
        Inherits UserControl
        Public Sub New()
            InitializeComponent()
            InitializeComponent()

            Dim states As New States()

            Dim stateNumber As Integer = 0

            For column As Integer = 0 To 4
                For row As Integer = 0 To 9
                    ' get the state abbrev
                    Dim stateAbbrev As String = states(stateNumber)

                    Dim theTextBlock As New TextBlock()
                    theTextBlock.FontSize = 22
                    theTextBlock.Text = stateAbbrev
                    theTextBlock.TextAlignment = TextAlignment.Center
                    theTextBlock.VerticalAlignment = VerticalAlignment.Center
                    LayoutRoot.Children.Add(theTextBlock)
                    Grid.SetRow(theTextBlock, row)
                    Grid.SetColumn(theTextBlock, column)

                    ' Add an image control to the grid
                    Dim theImage As New Image()

                    Dim st As New ScaleTransform()
                    st.ScaleX = 1
                    st.ScaleY = 1
                    theImage.RenderTransform = st

                    Dim uri As New Uri("Images/" & stateAbbrev & ".jpg", UriKind.Relative)
                    theImage.Source = New BitmapImage(uri)
                    theImage.Margin = New Thickness(10)
                    theImage.Opacity =.4
                    AddHandler theImage.MouseLeftButtonDown, AddressOf OnMouseLeftButtonDown

                    LayoutRoot.Children.Add(theImage)

                    ' then position it
                    Grid.SetRow(theImage, row)
                    Grid.SetColumn(theImage, column)

                    stateNumber += 1
                Next row
            Next column
        End Sub
        Private Sub AnimateImage(ByVal image As Image)
            Try

                Dim scaleXAnimation As New DoubleAnimation()
                scaleXAnimation.AutoReverse = True

                Dim scaleYAnimation As New DoubleAnimation()
                scaleYAnimation.AutoReverse = True

                Dim opacityAnimation As New DoubleAnimation()
                opacityAnimation.AutoReverse = True

                scaleXAnimation.From = 1
                scaleXAnimation.To = 5
                scaleYAnimation.From = 1
                scaleYAnimation.To = 5
                opacityAnimation.From =.4
                opacityAnimation.To = 1

                Dim sb As New Storyboard()

                Storyboard.SetTarget(scaleXAnimation, image.RenderTransform)
                Storyboard.SetTargetProperty(scaleXAnimation, New PropertyPath("ScaleX"))

                Storyboard.SetTarget(scaleYAnimation, image.RenderTransform)
                Storyboard.SetTargetProperty(scaleYAnimation, New PropertyPath("ScaleY"))

                Storyboard.SetTarget(opacityAnimation, image)
                Storyboard.SetTargetProperty(opacityAnimation, New PropertyPath("Opacity"))

                sb.Children.Add(scaleXAnimation)
                sb.Children.Add(scaleYAnimation)
                sb.Children.Add(opacityAnimation)

                sb.Begin()
            Catch ex As Exception
                Debug.WriteLine(ex.Message)
            End Try
        End Sub

        Private Sub AnimateImagesRandomly()
            Dim r As New Random(CInt(Fix(Date.Now.Ticks)))
            For Each uie As UIElement In LayoutRoot.Children
                Dim i As Image = TryCast(uie, Image)
                If i IsNot Nothing Then
                    AnimateImage(i)
                End If
            Next uie
        End Sub

        Private Overloads Sub OnMouseLeftButtonDown(ByVal sender As Object, ByVal ea As MouseButtonEventArgs)
            Dim image As Image = TryCast(sender, Image)
            AnimateImage(image)
        End Sub
    End Class
End Namespace
