Imports System.Text

Namespace ConsumeQuotesService
    Friend Class Program
        Shared Sub Main(ByVal args() As String)
            ' Get a single random quote
            Dim quotesServiceClient As New ServiceReference1.QuotesServiceClient()

            Dim quote As ServiceReference1.Quote = quotesServiceClient.GetAQuote()

            Console.WriteLine("Getting a single quote: " & quote.StrQuote)
            Console.WriteLine()

            ' Now add a quote
            Dim newQuote As New ServiceReference1.Quote()
            newQuote.StrQuote = "But to me nothing- the negative, the empty" & "- is exceedingly powerful."
            newQuote.StrOriginatorFirstName = "Alan"
            newQuote.StrOriginatorLastName = "Watts"

            quotesServiceClient.AddQuote(newQuote)

            Console.WriteLine("Added a quote")
            Console.WriteLine()

            ' Now get all the quotes
            Dim dataSet As DataSet = quotesServiceClient.GetAllQuotes()
            Dim tableQuotes As DataTable = dataSet.Tables(0)

            For Each dr As DataRow In tableQuotes.Rows
                Console.WriteLine(dr(0).ToString() & " " & dr(1).ToString() & "  " & dr(2).ToString())
            Next dr

            ' Now call GetAQuote asynchronously
            Console.WriteLine("Now fetching a quote asynchronously")
            Console.WriteLine()

            quotesServiceClient.BeginGetAQuote(AddressOf GetAQuoteCallback, quotesServiceClient)

            Console.WriteLine("Press enter to exit...")
            Console.ReadLine()


        End Sub


        Private Shared Sub GetAQuoteCallback(ByVal asyncResult As IAsyncResult)
            Dim quotesServiceClient As ServiceReference1.QuotesServiceClient = CType(asyncResult.AsyncState, ServiceReference1.QuotesServiceClient)


            Dim quote As ServiceReference1.Quote = quotesServiceClient.EndGetAQuote(asyncResult)

            Console.WriteLine(quote.StrQuote)
        End Sub


    End Class
End Namespace
