Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.ServiceModel.Web
Imports System.Text
Imports System.Web.Caching

Namespace WCFQuotesService
    ' NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "Service1" in code, svc and config file together.
    Public Class QuotesService
        Implements IQuotesService
        Private Function LoadQuotes() As QuotesCollection
            Dim quotesCollection As QuotesCollection
            quotesCollection = CType(HttpRuntime.Cache("quotesCollection"), QuotesCollection)
            If quotesCollection Is Nothing Then
                quotesCollection = New QuotesCollection()
                Dim strAppPath As String
                strAppPath = HttpRuntime.AppDomainAppPath
                Dim strFilePathXml As String = String.Format("{0}\App_Data\QuotesCollection.xml", strAppPath)
                Dim strFilePathSchema As String = String.Format("{0}\App_Data\QuotesCollection.xsd", strAppPath)
                quotesCollection.ReadXmlSchema(strFilePathSchema)
                quotesCollection.ReadXml(strFilePathXml)
                Dim cacheDependency As New CacheDependency(strFilePathXml)
                HttpRuntime.Cache.Insert("quotesCollection", quotesCollection, cacheDependency, Cache.NoAbsoluteExpiration, Cache.NoSlidingExpiration, CacheItemPriority.Default, Nothing)
            End If
            Return quotesCollection
        End Function

        Public Function GetAQuote() As Quote Implements IQuotesService.GetAQuote
            Dim quotesCollection As QuotesCollection = Me.LoadQuotes()
            Dim nNumQuotes As Integer = quotesCollection.Rows.Count

            Dim random As New Random()
            Dim nQuote As Integer = random.Next(nNumQuotes)
            Dim dataRow As DataRow = quotesCollection.Rows(nQuote)
            Dim quote As New Quote(CType(dataRow("Quote"), String), CType(dataRow("OriginatorLastName"), String), CType(dataRow("OriginatorFirstName"), String))
            Return quote
        End Function

        Public Sub AddQuote(ByVal quote As Quote) Implements IQuotesService.AddQuote
            Dim quotesCollection As QuotesCollection = Me.LoadQuotes()

            Dim dr As DataRow = quotesCollection.NewRow()
            dr(0) = quote.StrQuote
            dr(1) = quote.StrOriginatorLastName
            dr(2) = quote.StrOriginatorFirstName
            quotesCollection.Rows.Add(dr)

            Dim strAppPath As String
            strAppPath = HttpRuntime.AppDomainAppPath

            Dim strFilePathXml As String = String.Format("{0}\App_Data\QuotesCollection.xml", strAppPath)
            Dim strFilePathSchema As String = String.Format("{0}\App_Data\QuotesCollection.xsd", strAppPath)

            quotesCollection.WriteXmlSchema(strFilePathSchema)
            quotesCollection.WriteXml(strFilePathXml)
        End Sub

        Public Function GetAllQuotes() As DataSet Implements IQuotesService.GetAllQuotes
            Dim quotesCollection As QuotesCollection = LoadQuotes()
            Dim dataSet As New DataSet()
            dataSet.Tables.Add(quotesCollection)
            Return dataSet
        End Function


    End Class

End Namespace
